ygopro.ctos_follow_after("UPDATE_DECK", true, async (buffer, info, client, server, datas) => {
    var room = ROOM_all[client.rid];
    if (!room) {
        return null;
    }
    if (room.duel_stage != ygopro.constants.DUEL_STAGE.BEGIN) {
        return null;
    }
//   if (client.is_local) {
//       return null;
//  }

    var room_parameters = room.name.split('#', 2)[0].split(/[,，]/); //房间名的参数
    var MirrorMode = false;
    for(var parameter of room_parameters) {
        if (parameter.toUpperCase() == "MM") { //关键字[MM]
            MirrorMode = true;
            break;
        }
    }

    var AllowSelfDeck = false;
    for(var parameter of room_parameters) {
        if (parameter.toUpperCase() == "MD") { //关键字[MD]
            AllowSelfDeck = true;
            break;
        }
    }
    if (AllowSelfDeck && client.name.substr(0,4)=="[MD]") {
        return;
    }

    var deckindex = global.dc_decks_index;
    if (MirrorMode) {
		if (room.mm_deck == undefined) {
            global.dc_decks_index++;
            if (global.dc_decks_index == global.dc_decks_index_max) {
                   global.dc_decks_index = 0;
            }
            room.mm_deck = global.dc_decks_main[deckindex];
            room.mm_side = global.dc_decks_side[deckindex];
            room.mm_md5 = global.dc_decks_md5[deckindex];
            MirrorMode=false;
		}
        client.main = room.mm_deck;
        client.side = room.mm_side;
        var compat_deckbuf =  client.main.concat(client.side);
        client.deckMd5 = room.mm_md5;
    }
    else {
        global.dc_decks_index++;
        if (global.dc_decks_index == global.dc_decks_index_max) {
               global.dc_decks_index = 0;
        }
        client.main = global.dc_decks_main[deckindex];
        client.side = global.dc_decks_side[deckindex];
        var compat_deckbuf =  client.main.concat(client.side);
        client.deckMd5 = global.dc_decks_md5[deckindex];
//	ygopro.stoc_send_chat(client, "md5:"+global.dc_decks_md5[deckindex], ygopro.constants.COLORS.YELLOW);

    }

    try {
        ygopro.ctos_send(server, "UPDATE_DECK", {
            mainc: client.main.length,
            sidec: client.side.length,
            deckbuf: compat_deckbuf
        });
        ygopro.stoc_send_chat(client, "如果卡组有问题，请在决斗中于聊天框输入【/report 举报理由】进行举报。", ygopro.constants.COLORS.YELLOW);
        ygopro.stoc_send_chat(client, "注意：【卡组太弱】【有未知卡】并不是有效的举报理由，【额外不全】【构筑错误】才是。", ygopro.constants.COLORS.YELLOW);
        ygopro.stoc_send_chat(client, "编年史QQ群号：838595368。可在群内下载编年史客户端，解锁更多功能。", ygopro.constants.COLORS.YELLOW);
        ygopro.stoc_send_chat(client, "举报理由请尽量详细写明构筑的哪里有问题，不要只写个【构筑错误】。", ygopro.constants.COLORS.BABYBLUE);
        ygopro.stoc_send_chat(client, "有未知白板卡是因为你没有下载编年史独有卡。请加群下载，举报没用。", ygopro.constants.COLORS.BABYBLUE);
    }
    catch {
        var err_msg = "（由于卡组异常，被服务器端自动提交）";
        var err_md5 = global.dc_decks_md5[deckindex];
        var err_sql = "INSERT INTO DCReport VALUES(?,?,?,'')";
        var err_ip = "127.0.0.1";
        var err_sqlParams = [err_md5, err_ip, err_msg];
        log.info("READY_FAILURE : " + err_md5);
        ygopro.stoc_send_chat(client, "意外的错误，你可能抽到了无效卡组。请重新准备。", ygopro.constants.COLORS.YELLOW);
        ygopro.stoc_send_chat(client, "服务器将尝试将卡组举报。", ygopro.constants.COLORS.YELLOW);
        mysqldb.query(err_sql, err_sqlParams, function(err) {
            if (err) {
                global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
                log.info(err);
                ygopro.stoc_send_chat(client, "举报失败。卡组ID："+err_md5+"，请向管理员反映此情况。", ygopro.constants.COLORS.YELLOW);
                return;
            }
            ygopro.stoc_send_chat(client, "举报ID："+err_md5+"，可用编年史客户端查看并修改。", ygopro.constants.COLORS.YELLOW);
        });
    }

    if (MirrorMode) {
        return true;
    }

    var sql = "SELECT * FROM RandomDecks AS t1 JOIN (SELECT ROUND(RAND() * (SELECT MAX(id) FROM RandomDecks)) AS id) AS t2 WHERE t1.id >= t2.id ORDER BY t1.id LIMIT 1;"
    
    global.mysqldb.query(sql, null, function(err, result) {
        if (err) {
          global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
          log.info(err);
          return;
        }
        if (result == null || result.length == 0) {
            return null;
        }
        var buff_main = [];
        var buff_side = [];
        var cards = result[0].content.split(/[\r\n\t ]+/);
        var side = false;
        var valid = false;
        for (var i = 0; i < cards.length; i++) {
            var code = parseInt(cards[i].trim());
            if (!isNaN(code)) { 
                if (!side) {
                    buff_main.push(code);
                    valid = true;
                }
                else {
                    buff_side.push(code);
                }
            }
            else if (cards[i].substring(0, 5) == "!side") {
                side = true;
            }
        }
        if (valid) {
            dc_decks_main[deckindex] = buff_main;
            dc_decks_side[deckindex] = buff_side;
            dc_decks_md5[deckindex] = result[0].md5;
        }
    });
    return true;
});

ygopro.ctos_follow_before('CHAT', true, async function(buffer, info, client, server, datas) {
    room = ROOM_all[client.rid];
    if (!room) {
//	ygopro.stoc_send_chat(client, "失败：请在决斗中使用指令。", ygopro.constants.COLORS.YELLOW);
        return;
    }
    if (!client.deckMd5) {
//	ygopro.stoc_send_chat(client, "失败：卡组检索异常", ygopro.constants.COLORS.YELLOW);
        return;
    }
    var md5 = client.deckMd5;
    if (room.duel_stage != ygopro.constants.DUEL_STAGE.DUELING) {
//	ygopro.stoc_send_chat(client, "失败：未在有效的决斗期间", ygopro.constants.COLORS.YELLOW);
        return;
    }
    var msg = _.trim(info.msg);
    if (msg.substring(0, 7) != "/report") {
//	ygopro.stoc_send_chat(client, "失败：未知命令"+info.msg, ygopro.constants.COLORS.YELLOW);
        return;
    }
    msg = msg.substring(7);
    msg = _.trim(msg);
    if (msg.length < 2) {
        ygopro.stoc_send_chat(client, "失败：请以 /report 举报原因 的格式写明举报原因", ygopro.constants.COLORS.YELLOW);
        return;
    }
    //"CREATE TABLE DCReportServer(reporterIp varchar(255),reportDate DateTime)";
    var sql = "SELECT * FROM `DCReportServer` WHERE reporterIp=? AND reportDate > date_sub(now(), interval 5 minute)";
    sqlParams = [client.ip];
    mysqldb.query(sql, sqlParams, function(err, result) {
        if (err) {
            mysql.createConnection(settings.modules.cloud_replay.mysql);
            log.info(err);
            ygopro.stoc_send_chat(client, "服务器出现异常，请重试", ygopro.constants.COLORS.RED);
            return;
        }
        if (result.length > 0) {
            ygopro.stoc_send_chat(client, "举报功能正在冷却中，请稍后再试", ygopro.constants.COLORS.YELLOW);
            return;
        }
        sql = "INSERT INTO `DCReportServer` VALUES(?,now())";
        sqlParams = [client.ip];
        mysqldb.query(sql, sqlParams, function(err, result) {
            if (err) {
                global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
                log.info(err);
                ygopro.stoc_send_chat(client, "出现异常，请重试", ygopro.constants.COLORS.RED);
                return;
            }
            sql = "SELECT * FROM DCDeckNoChangeList WHERE deckMd5=?";
            sqlParams = [md5];
            mysqldb.query(sql, sqlParams, function(err, result) {
                if (err) {
                    global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
                    log.info(err);
                    ygopro.stoc_send_chat(client, "例外库无法检索卡组，提交失败", ygopro.constants.COLORS.RED);
                    return;
                }
                if (result.length > 0) {
                    ygopro.stoc_send_chat(client, "此卡组已被人工判定为无需修改，提交失败。", ygopro.constants.COLORS.RED);
                    ygopro.stoc_send_chat(client, "由于进行了恶意提交，你会被封禁24小时。", ygopro.constants.COLORS.RED);
                    ygopro.stoc_send_chat(client, "卡组ID："+md5, ygopro.constants.COLORS.RED);
                    ygopro.stoc_send_chat(client, "如有疑问，请记录上述字符串，并向编年史群的管理者反馈："+md5, ygopro.constants.COLORS.RED);
                    sql = "INSERT INTO `DCReportServer` VALUES(?,now())";
                    return;
                }
                msg = (new Date().toString()) + " - 由服务器端提交（提交者：" + client.name + "，云录像：R#"+room.cloud_replay_id+"）\r\n\r\n" + msg;
                sql = "INSERT INTO DCReport VALUES(?,?,?,'')";
                sqlParams = [md5, client.ip, msg];
                mysqldb.query(sql, sqlParams, function(err, result) {
                    if (err) {
                        global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
                        log.info(err);
                        ygopro.stoc_send_chat(client, "提交失败", ygopro.constants.COLORS.RED);
                        return;
                    }
                    ygopro.stoc_send_chat(client, "提交成功，感谢您的举报。\n举报ID为"+md5+"，可用编年史客户端查看并修改。", ygopro.constants.COLORS.YELLOW);
                });
            });
        });
    });
    return true;
});
ygopro.stoc_follow_after("DUEL_START", false, (buffer, info, client, server, datas) => {
    var room = ROOM_all[client.rid];
    room.mm_deck = null;
});

ygopro.stoc_follow_after("CHANGE_SIDE", true, (buffer, info, client, server, datas) => {
    var room = ROOM_all[client.rid];
    if (!room) {
        return false;
    }
     
//    if (client.is_local) {
//        return false;
//    }

    var room_parameters = room.name.split('#', 2)[0].split(/[,，]/); //房间名的参数
    var MirrorMode = false;
    for(var parameter of room_parameters) {
        if (parameter.toUpperCase() == "MM") { //关键字[MM]
            MirrorMode = true;
            break;
        }
    }

    var deckindex = global.dc_decks_index;
    if (MirrorMode) {
		if (room.mm_deck == null) {
            global.dc_decks_index++;
            if (global.dc_decks_index == global.dc_decks_index_max) {
                   global.dc_decks_index = 0;
            }
            room.mm_deck = global.dc_decks_main[deckindex];
            room.mm_side = global.dc_decks_side[deckindex];
            room.mm_md5 = global.dc_decks_md5[deckindex];
            MirrorMode=false;
		}
        client.main = room.mm_deck;
        client.side = room.mm_side;
        var compat_deckbuf =  client.main.concat(client.side);
        client.deckMd5 = room.mm_md5;
    }
    else {
        global.dc_decks_index++;   
        if (global.dc_decks_index == global.dc_decks_index_max) {
               global.dc_decks_index = 0;
        }
        client.main = global.dc_decks_main[deckindex];
        client.side = global.dc_decks_side[deckindex];
        var compat_deckbuf =  client.main.concat(client.side);
        client.deckMd5 = global.dc_decks_md5[deckindex];
    }
    try {
        ygopro.ctos_send(server, "UPDATE_DECK", {
            mainc: client.main.length,
            sidec: client.side.length,
            deckbuf: compat_deckbuf
        });
    }
    catch {
        var err_msg = "（由于卡组异常，被服务器端自动提交）";
        var err_md5 = global.dc_decks_md5[deckindex];
        var err_sql = "INSERT INTO DCReport VALUES(?,?,?,'')";
        var err_ip = "127.0.0.1";
        var err_sqlParams = [err_md5, err_ip, err_msg];
        log.info("READY_FAILURE : " + err_md5);
        ygopro.stoc_send_chat(client, "意外的错误，你可能抽到了无效卡组。请重新准备。", ygopro.constants.COLORS.YELLOW);
        ygopro.stoc_send_chat(client, "服务器将尝试将卡组举报。", ygopro.constants.COLORS.YELLOW);
        mysqldb.query(err_sql, err_sqlParams, function(err) {
            if (err) {
                global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
                log.info(err);
                ygopro.stoc_send_chat(client, "举报失败。卡组ID："+err_md5+"，请向管理员反映此情况。", ygopro.constants.COLORS.YELLOW);
                return;
            }
            ygopro.stoc_send_chat(client, "举报ID："+err_md5+"，可用编年史客户端查看并修改。", ygopro.constants.COLORS.YELLOW);
        });
    }

    if (MirrorMode) {
        return true;
    }

    var sql = "SELECT * FROM RandomDecks AS t1 JOIN (SELECT ROUND(RAND() * (SELECT MAX(id) FROM RandomDecks)) AS id) AS t2 WHERE t1.id >= t2.id ORDER BY t1.id LIMIT 1;"
    
    global.mysqldb.query(sql, null, function(err, result) {
        if (err) {
          global.mysqldb=mysql.createConnection(global.settings.modules.cloud_replay.mysql);
          log.info(err);
          return;
        }
        if (result == null || result.length == 0) {
            return null;
        }
        var buff_main = [];
        var buff_side = [];
        var cards = result[0].content.split(/[\r\n\t ]+/);
        var side = false;
        var valid = false;
        for (var i = 0; i < cards.length; i++) {
            var code = parseInt(cards[i].trim());
            if (!isNaN(code)) { 
                if (!side) {
                    buff_main.push(code);
                    valid = true;
                }
                else {
                    buff_side.push(code);
                }
            }
            else if (cards[i].substring(0, 5) == "!side") {
                side = true;
            }
        }
        if (valid) {
            dc_decks_main[deckindex] = buff_main;
            dc_decks_side[deckindex] = buff_side;
            dc_decks_md5[deckindex] = result[0].md5;
        }
    });
    return true;
});
